onEvent('recipes', e => {

  e.remove({ output: 'pipez:fluid_pipe' })
  e.remove({ output: 'pipez:item_pipe' })
  e.remove({ output: 'pipez:energy_pipe' })
  e.remove({ output: 'pipez:gas_pipe' })
  e.remove({ output: 'pipez:universal_pipe' })
  e.remove({ output: '#pipez:upgrades' })






  e.shaped('4x pipez:fluid_pipe', [
    '333',
    '121',
    '333'
  ], {
    1: 'minecraft:bucket', 2: 'minecraft:glass', 3: 'minecraft:iron_ingot'
  })

  e.shaped('6x pipez:item_pipe', [
    '333',
    '121',
    '333'
  ], {
    1: 'minecraft:redstone_block', 2: 'minecraft:hopper', 3: 'mekanism:ingot_steel'
  })

  e.shaped('8x pipez:energy_pipe', [
    '333',
    '121',
    '333'
  ], {
    1: 'minecraft:redstone_block', 2: 'extendedcrafting:redstone_ingot', 3: 'immersiveengineering:connector_hv'
  })

  e.shaped('4x pipez:gas_pipe', [
    '333',
    '121',
    '333'
  ], {
    1: 'minecraft:redstone_block', 2: 'mekanism:basic_chemical_tank', 3: 'pipez:fluid_pipe'
  })

  e.shaped('pipez:basic_upgrade', [
    '313',
    '121',
    '313'
  ], {
    1: 'mekanism:ingot_steel', 2: 'pneumaticcraft:unassembled_pcb', 3: 'minecraft:redstone'
  })

  e.shaped('pipez:improved_upgrade', [
    '313',
    '121',
    '313'
  ], {
    1: 'kubejs:reinforcedpcb', 2: 'pipez:basic_upgrade', 3: 'extendedcrafting:advanced_component'
  })

  e.shaped('pipez:ultimate_upgrade', [
    '313',
    '121',
    '313'
  ], {
    1: 'extendedcrafting:ultimate_component', 2: 'pipez:advanced_upgrade', 3: 'mekanism:ultimate_control_circuit'
  })


})